 stack=&0100
 util0=&A8:util1=&AA:util2=&AC:util3=&AE
 scratch0=&B0:scratch1=&B2:scratch2=&B4:scratch3=&B6
 scratch4=&B8:scratch5=&BA:scratch6=&BC:scratch7=&BE
 dedicated=&C0
 osbyte=&FFF4:oswrch=&FFEE:osasci=&FFE3
 fscv=&21E
 FOR opt%=4 TO 7 STEP 3
 O%=&6000:P%=&8000
 [
 OPT opt%
.entry
 JMP language_entry
 JMP service_entry
 EQUB &82
 EQUB copyright - entry
 EQUB &00
 EQUS "User Port Filing System"
.copyright
 EQUB &00
 EQUS "(C) A.J. Wijma"
 EQUB &00
 EQUD &00000000
\\\\\\\\\\\\\\\\\\\
.hex                         \ routine to show hex chars
 PHP
 PHA
 TXA
 PHA
 TSX
 LDA stack+2,X
 PHA
 LSR A
 LSR A
 LSR A
 LSR A
 TAX
 LDA hextable,X
 JSR oswrch                  \ write high nibble
 PLA
 AND #&0F
 TAX
 LDA hextable,X
 JSR oswrch                  \ write low nibble
 PLA
 TAX
 PLA
 PLP
 RTS
.hextable
 EQUS "0123456789ABCDEF"
\\\\\\\\\\\\\\\\\\\
.show_title                  \ show rom title
 PHA
 TXA
 PHA
 LDX #&00
.s03_loop1
 LDA &8009,X
 INX
 CMP #&00
 BEQ s03_end
 JSR oswrch
 JMP s03_loop1
.s03_end
 PLA
 TAX
 PLA
 RTS
\\\\\\\\\\\\\\\\\\\
.osfsc
 JMP (fscv)
\\\\\\\\\\\\\\\\\\\
.init
 PHA
 LDA #&7F
 STA &FE6E                   \ disable all interrupts
 STA &FE6D                   \ clear ifr
 LDA #&00
 STA &FE62                   \ all input ddrb
 STA &FE60                   \ orb=0
 LDA &02
 STA &FE6B                   \ latch port b
 LDA &FF
 STA &FE68                   \ time-out counter
 STA &FE69
 LDA &FE6C                   \ set cb1 & 2 up for
 AND #&0F                    \ handshaking mode
 ORA #&80
 STA &FE6C
 PLA
 RTS
\\\\\\\\\\\\\\\\\\\
.setup                       \ routine for setting up the
 PHA                         \ filing system (doing the
 TXA                         \ appropriate calls and setting
 PHA                         \ up the vectors)
 TYA
 PHA
 JSR init
 LDA #&06
 JSR osfsc                   \ A=6 vector are to be redefined
 LDA #&A8
 LDX #&00
 LDY #&FF
 JSR osbyte                  \ Get extended vector array address
 STX scratch0
 STY scratch0+1
 PHP
 SEI
 LDX #&00
 LDY #&1B
.setup_loop1                  \ Loop for setting normal vector to
 TYA                         \ extended vectors
 STA &212,X
 INX
 LDA #&FF
 STA &212,X
 INX
 INY
 INY
 INY
 CPX #&0E
 BNE setup_loop1
 LDX #&00
 LDY #&1B
.setup_loop2                  \ Loop to initialize extended vectors
 LDA setup_table,X
 STA (scratch0),Y
 INX
 INY
 LDA setup_table,X
 STA (scratch0),Y
 INY
 LDA &F4
 STA (scratch0),Y
 INX
 INY
 CPX #&0E
 BNE setup_loop2
 PLP
 LDA #&8F
 LDX #&0F
 LDY #&00
 JSR osbyte                  \ Issue service call &12
 PLA
 TAY
 PLA
 TAX
 PLA
 RTS
.setup_table
 EQUW xfilev
 EQUW xargsv
 EQUW xbgetv
 EQUW xbputv
 EQUW xgbpbv
 EQUW xfindv
 EQUW xfscv
\\\\\\\\\\\\\\\\\\\
.send                        \ send byte over user port
 PHA                         \ with handshaking and time-out
 LDA #&FF
 STA &FE62                   \ ddrb all pins to output
 PLA
 STA &FE60
.send_loop1
 LDA #&FF
 STA &FE69                   \ start time-out counter
 LDA #&30
.send_loop2
 BIT &FE6D
 BEQ send_loop2              \ wait for 'data taken' or time-out
 LDA &FE6D
 AND #&10                    \ is it a time-out?
 BNE send_good
 LDA &FF
 BMI send_escape
 DEX
 BMI send_tmout
 JMP send_loop1
.send_good
 STA &FE62                   \ ddrb all pins to input
 LDA &FE60
 CLC
 RTS
.send_escape
 LDA #&11
 JSR error
.send_tmout
 LDA #&B0
 JSR error
\\\\\\\\\\\\\\\\\\\
.recv
 LDA #&00
 STA &FE60
 STA &FE62
.recv_loop1
 LDA #&FF
 STA &FE69
 LDA #&30
.recv_loop2
 BIT &FE6D
 BEQ recv_loop2
 LDA &FE6D
 AND #&10
 BNE recv_good
 LDA &FF
 BMI recv_escape
 DEX
 BMI recv_tmout
 JMP recv_loop1
.recv_good
 LDA &FE60
 RTS
.recv_escape
 LDA #&11
 JSR error
.recv_tmout
 LDA #&B0
 JSR error
\\\\\\\\\\\\\\\\\\\
.stringsend
 PHA
 TYA
 PHA
 CLD
 LDY #&FF
.stringsend_loop1
 INY
 LDA (scratch1),Y
 CMP #&20
 BCS stringsend_loop1
 INY
 TYA
 CLC
 ADC scratch1
 STA scratch2
 LDA scratch1+1
 ADC #&00
 STA scratch2+1
 JSR blocksend
 PLA
 TAY
 PLA
 RTS
\\\\\\\\\\\\\\\\\\\
.blocksend
 PHA
 TXA
 PHA
 TYA
 PHA
 LDX scratch7
 LDY #&00
.blocksend_loop1
 LDA (scratch1),Y
 JSR send
 INC scratch1
 BNE blocksend_noc
 INC scratch1+1
.blocksend_noc
 LDA scratch1
 CMP scratch2
 BNE blocksend_loop1
 LDX scratch7
 LDA scratch1+1
 CMP scratch2+1
 BNE blocksend_loop1
\LDA (scratch1),Y
\JSR send
 PLA
 TAY
 PLA
 TAX
 PLA
 RTS
\\\\\\\\\\\\\\\\\\\
.blockrecv
 PHA
 TXA
 PHA
 TYA
 PHA
 LDX scratch7
 LDY #&00
.blockrecv_loop1
 JSR recv
 STA (scratch1),Y
 INC scratch1
 BNE blockrecv_noc
 INC scratch1+1
.blockrecv_noc
 LDA scratch1
 CMP scratch2
 BNE blockrecv_loop1
 LDX scratch7
 LDA scratch1+1
 CMP scratch2+1
 BNE blockrecv_loop1
\JSR recv
\STA (scratch1),Y
 PLA
 TAY
 PLA
 TAX
 PLA
 RTS
\\\\\\\\\\\\\\\\\\\
.error
 LDY #&00
 STY &FE62
 CMP #&00
 BNE error_loop1
 RTS
.error_loop1
 CMP error_table,Y
 BEQ error_good
 LDX error_table,Y
 CPX #&FF
 BEQ error_good
 INY
 JMP error_loop1
.error_good
 LDX #&00
 STX stack
 DEY
.error_loop2
 INX
 INY
 LDA error_table,Y
 STA stack,X
 BNE error_loop2
 JMP stack
.error_table
 EQUB &11
 EQUS "Escape"
 EQUB &00
 EQUB &B0
 EQUS "Time out"
 EQUB &00
 EQUB &D6
 EQUS "File not found"
 EQUB &00
 EQUB &FE
 EQUS "Bad command"
 EQUB &00
 EQUB &FF
 EQUS "Unknown error"
 EQUB &00
\\\\\\\\\\\\\\\\\\\
.language_entry              \ This is not a language!
 RTS
\\\\\\\\\\\\\\\\\\\
.service_entry
 PHP
 PHA
 TXA
 PHA
 TYA
 PHA
 TSX
 LDA stack+3,X               \ Load service type
 CMP #&03
 BNE not_s03
 JSR s03
.not_s03
 CMP #&04
 BNE not_s04
 JSR s04
.not_s04
 CMP #&09
 BNE not_s09
 JSR s09
.not_s09
 CMP #&0F
 BNE not_s0F
 JSR s0F
.not_s0F
 CMP #&10
 BNE not_s10
 JSR s10
.not_s10
 CMP #&12
 BNE not_s12
 JSR s12
.not_s12
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.s03                         \ Auto-boot initialisation call
 JSR show_title
 LDA #&0D
 JSR osasci
 JSR osasci
 RTS
\\\\\\\\\\\\\\\\\\\
.s04                         \ Unrecognised command call
 LDA &F3                     \ Save pointer to command
 PHA
 LDA &F2
 PHA
 TYA
 CLD
 CLC
 ADC &F2                     \ Add Y to avoid overflow while
 STA &F2                     \ checking the command
 LDA &F3
 ADC #&00
 STA &F3
 LDY #&00
.s04_loop                    \ Command check loop
 LDA (&F2),Y
 AND #&DF
 CMP s04_command,Y           \ Is this our command?
 BNE s04_nomatch
 INY
 CMP #&0D
 BNE s04_loop
 JSR setup
 TSX
 LDA #&00                    \ Yes it is!
 STA stack+7,X               \ So change the accumulator in the stack
.s04_nomatch                 \ No match
 PLA
 STA &F2
 PLA
 STA &F3
 RTS
.s04_command
 EQUS "USER"                  \ This is our command
 EQUB &0D
\\\\\\\\\\\\\\\\\\\
.s09
 LDA #&0D
 JSR osasci
 JSR show_title
 LDA #&0D
 JSR osasci
 RTS
\\\\\\\\\\\\\\\\\\\
.s0F
 RTS
\\\\\\\\\\\\\\\\\\\
.s10
 RTS
\\\\\\\\\\\\\\\\\\\
.s12
 RTS
\\\\\\\\\\\\\\\\\\\
.xfilev
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 CMP #&00
 BNE not_xfilev00
 JSR xfilev00
 JMP end_xfilev
.not_xfilev00
 CMP #&01
 BNE not_xfilev01
 JSR xfilev01
 JMP end_xfilev
.not_xfilev01
 CMP #&02
 BNE not_xfilev02
 JSR xfilev02
 JMP end_xfilev
.not_xfilev02
 CMP #&03
 BNE not_xfilev03
 JSR xfilev03
 JMP end_xfilev
.not_xfilev03
 CMP #&04
 BNE not_xfilev04
 JSR xfilev04
 JMP end_xfilev
.not_xfilev04
 CMP #&05
 BNE not_xfilev05
 JSR xfilev05
 JMP end_xfilev
.not_xfilev05
 CMP #&06
 BNE not_xfilev06
 JSR xfilev06
 JMP end_xfilev
.not_xfilev06
\CMP #&FF
\BNE not_xfilevFF
 JSR xfilevFF
 JMP end_xfilev
.not_xfilevFF
 PHA
 LDA #&00
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
.end_xfilev
 TSX
 STA stack+3,X
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xfilev00
 PHA
 LDA #&00
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 JSR xfilev_spb
 LDX #&10
 JSR recv
 JSR error
 LDX #&10
 JSR recv
 STA scratch1
 JSR recv
 STA scratch1+1
 LDX #&10
 JSR recv
 STA scratch2
 JSR recv
 STA scratch2+1
 LDX #&30
 STX scratch7
 JSR blocksend
 LDA #&01
 RTS
\\\\\\\\\\\\\\\\\\\
.xfilev01
.xfilev02
.xfilev03
.xfilev04
.xfilev05
.xfilev06
 PHA
 LDA #&00
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 LDA #&00
 RTS
\\\\\\\\\\\\\\\\\\
.xfilevFF
 PHA
 LDA #&00
 LDX #&10
 JSR send
 PLA
 JSR send
 LDX #&10
 JSR recv
 JSR error
 JSR xfilev_spb
 LDX #&10
 JSR recv
 JSR error
.xfilevFF_sub
 LDX #&10
 JSR recv
 STA scratch1
 JSR recv
 STA scratch1+1
 LDX #&10
 JSR recv
 STA scratch2
 JSR recv
 STA scratch2+1
 LDX #&30
 STX scratch7
 JSR blockrecv
 LDA #&01
 RTS
\\\\\\\\\\\\\\\\\\\
.xfilev_spb
 LDY #&00
 LDA (scratch0),Y
 STA scratch1
 INY
 LDA (scratch0),Y
 STA scratch1+1
 LDX #&10
 STX scratch7
 JSR stringsend
 LDA scratch0
 CLC
 ADC #&02
 STA scratch1
 LDA scratch0+1
 ADC #&00
 STA scratch1+1
 LDA scratch1
 CLC
 ADC #&10
 STA scratch2
 LDA scratch1+1
 ADC #&00
 STA scratch2+1
 LDX #&10
 STX scratch7
 JSR blocksend
 RTS
\\\\\\\\\\\\\\\\\\\
.xargsv
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 PHA
 LDA #&01
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xbgetv
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 PHA
 LDA #&02
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xbputv
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 PHA
 LDA #&03
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xgbpbv
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 PHA
 LDA #&04
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xfindv
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 CMP #&00
 BNE not_xfindv00
 JSR xfindv00
 JMP end_xfindv
.not_xfindv00
 CMP #&40
 BNE not_xfindv40
 JSR xfindv40
 JMP end_xfindv
.not_xfindv40
 CMP #&80
 BNE not_xfindv80
 JSR xfindv80
 JMP end_xfindv
.not_xfindv80
 CMP #&C0
 BNE not_xfindvC0
 JSR xfindvC0
 JMP end_xfindv
.not_xfindvC0
 PHA
 LDA #&05
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
.end_xfindv
 TSX
 STA stack+3,X
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xfindv00
.xfindv40
.xfindv80
.xfindvC0
 PHA
 LDA #&05
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 LDA #&00
 RTS
\\\\\\\\\\\\\\\\\\\
.xfscv
 PHP
 STX scratch0
 STY scratch0+1
 PHA
 TXA
 PHA
 TYA
 PHA
 CLD
 TSX
 LDA stack+3,X
 CMP #&02
 BNE not_xfscv02
 JSR xfscv02
 JMP end_xfscv
.not_xfscv02
 CMP #&03
 BNE not_xfscv03
 JSR xfscv03
 JMP end_xfscv
.not_xfscv03
 CMP #&04
 BNE not_xfscv04
 JSR xfscv04
 JMP end_xfscv
.not_xfscv04
 CMP #&05
 BNE not_xfscv05
 JSR xfscv05
 JMP end_xfscv
.not_xfscv05
 CMP #&08
 BNE not_xfscv08
 JMP end_xfscv
.not_xfscv08
 PHA
 LDA #&06
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
.end_xfscv
 TSX
 STA stack+3,X
 PLA
 TAY
 PLA
 TAX
 PLA
 PLP
 RTS
\\\\\\\\\\\\\\\\\\\
.xfscv02
 PHA
 LDA #&06
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 LDA scratch0
 STA scratch1
 LDA scratch0+1
 STA scratch1+1
 LDX #&10
 STX scratch7
 JSR stringsend
 LDX #&30
 JSR recv
 JSR error
 JSR xfilevFF_sub
 LDX #&10
 JSR recv
 STA scratch1
 JSR recv
 STA scratch1+1
 JMP (scratch1)
\\\\\\\\\\\\\\\\\\\
.xfscv03
 PHA
 LDA #&06
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 LDA scratch0
 STA scratch1
 LDA scratch0+1
 STA scratch1+1
 LDX #&10
 STX scratch7
 JSR stringsend
 LDX #&30
 JSR recv
 CMP #&00
 BNE xfscv03_not00
.xfscv03_loop1
 LDX #&10
 JSR recv
 CMP #&00
 BEQ xfscv03_xloop1
 JSR oswrch
 JMP xfscv03_loop1
.xfscv03_xloop1
 RTS
.xfscv03_not00
 CMP #&FF
 BNE xfscv03_notFF
 LDX #&10
 JSR recv
 JSR error
.xfscv03_notFF
 JSR xfilevFF_sub
 LDX #&10
 JSR recv
 STA scratch1
 JSR recv
 STA scratch1+1
 JMP (scratch1)
 JMP xfscv02
\\\\\\\\\\\\\\\\\\\
.xfscv04
 JMP xfscv02
\\\\\\\\\\\\\\\\\\\
.xfscv05
 PHA
 LDA #&06
 LDX #&10
 JSR send
 PLA
 JSR send
 JSR recv
 JSR error
 LDA scratch0
 STA scratch1
 LDA scratch0+1
 STA scratch1+1
 LDX #&10
 STX scratch7
 JSR stringsend
 LDX #&30
 JSR recv
 JSR error
.xfscv05_loop1
 LDX #&10
 JSR recv
 CMP #&00
 BEQ xfscv05_xloop1
 JSR oswrch
 JMP xfscv05_loop1
.xfscv05_xloop1
 RTS
\\\\\\\\\\\\\\\\\\\
 ]
NEXT

